!--------------------- BEGIN small_function.f90 BEGIN ---------------------
! @file small_function.f90                                                 
! @author jlinford                                                         
! @date 2012-06-22 15:43:23.213954                                         
! @brief The ODE function of the chemical model                            
!                                                                          
! The ODE function of the chemical model                                   
!                                                                          
! This file was generated by Kppa: http://www.paratools.com/Kppa           
!--------------------------------------------------------------------------


MODULE small_function


    IMPLICIT NONE




    CONTAINS

!---------------------------------- Fun -----------------------------------
! The ODE function of the chemical model                                   
!                                                                          
! @param[in]     var    Variable species concentrations                    
! @param[in]     fix    Fixed species concentrations                       
! @param[in]     rct    Reaction rates                                     
! @param[out]    vardot The ODE function                                   
!--------------------------------------------------------------------------
    SUBROUTINE Fun(var, fix, rct, vardot)
        IMPLICIT NONE

        REAL(4), INTENT(IN) :: var(5)
        REAL(4), INTENT(IN) :: fix(2)
        REAL(4), INTENT(IN) :: rct(10)
        REAL(4), INTENT(OUT) :: vardot(5)

        REAL(4) :: r0
        REAL(4) :: r1
        REAL(4) :: r2
        REAL(4) :: r3
        REAL(4) :: r4
        REAL(4) :: r5
        REAL(4) :: r6
        REAL(4) :: r7
        REAL(4) :: r8
        REAL(4) :: r9

        r0 = fix(2)*rct(1)
        r1 = 8.018e-17*fix(2)*var(2)
        r2 = rct(3)*var(3)
        r3 = 1.576e-15*var(2)*var(3)
        r4 = rct(5)*var(3)
        r5 = 7.11e-11*fix(1)*var(1)
        r6 = 1.2e-10*var(1)*var(3)
        r7 = 6.062e-15*var(3)*var(4)
        r8 = 1.069e-11*var(2)*var(5)
        r9 = rct(10)*var(5)

        vardot(1) = r4 - r5 - r6
        vardot(2) = 2.0*r0 - r1 + r2 - r3 + r5 - r8 + r9
        vardot(3) = r1 - r2 - r3 - r4 - r6 - r7
        vardot(4) = -r7 + r8 + r9
        vardot(5) = r7 - r8 - r9

    END SUBROUTINE Fun


END MODULE small_function
!----------------------- END small_function.f90 END -----------------------
