!---------------------- BEGIN small_solve.f90 BEGIN -----------------------
! @file small_solve.f90                                                    
! @author jlinford                                                         
! @date 2012-06-22 15:43:23.278446                                         
! @brief Solve Ax=b by forward-backward substitution                       
!                                                                          
! Solve Ax=b by forward-backward substitution                              
!                                                                          
! This file was generated by Kppa: http://www.paratools.com/Kppa           
!--------------------------------------------------------------------------


MODULE small_solve

    USE small_parameters

    IMPLICIT NONE




    CONTAINS

!--------------------------------- Solve ----------------------------------
! Solve Ax=b in place by back substitution                                 
!                                                                          
! @param[in]     A Row-compressed matrix with zero fill                    
! @param[in,out] x Input and solution vector                               
!--------------------------------------------------------------------------
    SUBROUTINE Solve(A, x)
        IMPLICIT NONE

        REAL(4), INTENT(IN) :: A(19)
        REAL(4), INTENT(INOUT) :: x(5)

        REAL(4) :: x0
        REAL(4) :: x1
        REAL(4) :: x2
        REAL(4) :: x3
        REAL(4) :: x4

        x0 = x(1)
        x1 = -A(3)*x0 + x(2)
        x2 = -A(7)*x0 - A(8)*x1 + x(3)
        x3 = -A(12)*x1 - A(13)*x2 + x(4)
        x4 = -A(16)*x1 - A(17)*x2 - A(18)*x3 + x(5)

        x4 = x4/A(19)
        x3 = (-A(15)*x4 + x3)/A(14)
        x2 = (-A(10)*x3 - A(11)*x4 + x2)/A(9)
        x1 = (-A(5)*x2 - A(6)*x4 + x1)/A(4)
        x0 = (-A(2)*x2 + x0)/A(1)
        x(5) = x4
        x(4) = x3
        x(3) = x2
        x(2) = x1
        x(1) = x0

    END SUBROUTINE Solve


END MODULE small_solve
!------------------------ END small_solve.f90 END -------------------------
